module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 11);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

module.exports = require("react");

/***/ }),
/* 1 */
/***/ (function(module, exports) {

module.exports = require("react-fela");

/***/ }),
/* 2 */
/***/ (function(module, exports) {

module.exports = require("react-redux");

/***/ }),
/* 3 */
/***/ (function(module, exports) {

module.exports = require("react-apollo");

/***/ }),
/* 4 */
/***/ (function(module, exports) {

module.exports = require("@workbench-stack/client-modal-redux");

/***/ }),
/* 5 */
/***/ (function(module, exports) {

module.exports = require("@finder-stack/client-redux");

/***/ }),
/* 6 */
/***/ (function(module, exports) {

module.exports = require("classnames");

/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const client_theme_redux_1 = __webpack_require__(26);
const toggleReplaceButtonColors = {
    light: {
        backgroundHover: 'rgba(0, 0, 0, 0.1)',
    },
    dark: {
        backgroundHover: 'rgba(255, 255, 255, 0.1)',
    },
    hc: {
        backgroundHover: 'rgba(255, 255, 255, 0.1)',
    },
};
const inputColors = {
    light: {
        background: '#ccc',
        foreground: '#000',
    },
    dark: {
        background: '#373737',
        foreground: '#fff',
    },
    hc: {
        background: 'transparent',
        foreground: '#fff',
    },
};
const contentNodeColors = {
    light: {
        background: '#e3e6ef',
    },
    dark: {
        background: '#2a2d2e',
    },
    hc: {
        background: '2a2d2e',
    },
};
const contentNodeSelectedColors = {
    light: {
        background: '#3399ff',
        foreground: '#fff',
    },
    dark: {
        background: '#094771',
        foreground: 'inherit',
    },
    hc: {
        background: '#094771',
        foreground: 'inherit',
    },
};
const scrollColors = {
    light: {
        thumbBackground: '#ccc',
    },
    dark: {
        thumbBackground: '#373737',
    },
    hc: {
        thumbBackground: '#373737',
    },
};
const highlightColors = {
    light: {
        background: '#f0c1a3',
        replaceBackground: '#e2e8d4',
        delBackground: '#f6c3c3',
    },
    dark: {
        background: '#66371a',
        replaceBackground: '#3d432f',
        delBackground: '#511e1e',
    },
    hc: {
        background: '#66371a',
        replaceBackground: '#3d432f',
        delBackground: '#511e1e',
    },
};
exports.getToggleReplaceButtonColors = (theme) => {
    const backgroundHover = client_theme_redux_1.getThemeSetting(theme.name, 'finderWidget.toggleReplaceButton.backgroundHover', toggleReplaceButtonColors[theme.name].backgroundHover);
    return {
        '&:hover': {
            'background-color': `${backgroundHover} !important`,
        },
    };
};
exports.getInputColors = (theme) => {
    const foreground = client_theme_redux_1.getThemeSetting(theme.name, 'finderWidget.input.foreground', inputColors[theme.name].foreground);
    const background = client_theme_redux_1.getThemeSetting(theme.name, 'finderWidget.input.background', inputColors[theme.name].background);
    return {
        '& input': {
            background,
            color: foreground,
            border: 'none',
            '&:focus': {
                border: '1px solid #387ba9 !important',
            },
        },
    };
};
exports.getNodeContentColors = (theme) => {
    const background = client_theme_redux_1.getThemeSetting(theme.name, 'finderResults.contentNode.background', contentNodeColors[theme.name].background);
    const selectedBackground = client_theme_redux_1.getThemeSetting(theme.name, 'finderResults.contentNode.selected.background', contentNodeSelectedColors[theme.name].background);
    const selectedForeground = client_theme_redux_1.getThemeSetting(theme.name, 'finderResults.contentNode.selected.foreground', contentNodeSelectedColors[theme.name].foreground);
    return {
        '&:hover': {
            background,
        },
        '&.selected': {
            background: `${selectedBackground} !important`,
            color: `${selectedForeground} !important`,
        },
    };
};
exports.getScrollColors = (theme) => {
    const thumbBackground = client_theme_redux_1.getThemeSetting(theme.name, 'finderResults.scrollBarThumbBackground', scrollColors[theme.name].thumbBackground);
    return {
        '&::-webkit-scrollbar-thumb': {
            background: thumbBackground,
        },
    };
};
exports.getHighlightColors = (theme) => {
    const background = client_theme_redux_1.getThemeSetting(theme.name, 'finderResults.highlight.background', highlightColors[theme.name].background);
    const replaceBackground = client_theme_redux_1.getThemeSetting(theme.name, 'finderResults.highlight.replaceBackground', highlightColors[theme.name].replaceBackground);
    const delBackground = client_theme_redux_1.getThemeSetting(theme.name, 'finderResults.highlight.delBackground', highlightColors[theme.name].delBackground);
    return {
        '& mark': {
            color: 'inherit',
            backgroundColor: background,
            '&.green': {
                backgroundColor: replaceBackground,
            },
        },
        '& del': {
            color: 'inherit',
            backgroundColor: delBackground,
        },
    };
};


/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const collapsed = "%3Csvg xmlns='http://www.w3.org/2000/svg' width='16' height='16'%3E%3Cpath fill='#646465' d='M6 4v8l4-4-4-4zm1 2.414l1.586 1.586-1.586 1.586v-3.172z'/%3E%3C/svg%3E";
const collapsedDark = "%3Csvg xmlns='http://www.w3.org/2000/svg' width='16' height='16'%3E%3Cpath fill='#e8e8e8' d='M6 4v8l4-4-4-4zm1 2.414l1.586 1.586-1.586 1.586v-3.172z'/%3E%3C/svg%3E";
const expanded = "%3Csvg xmlns='http://www.w3.org/2000/svg' width='16' height='16'%3E%3Cpath fill='#646465' d='M11 10.07h-5.656l5.656-5.656v5.656z'/%3E%3C/svg%3E";
const expandedDark = "%3Csvg xmlns='http://www.w3.org/2000/svg' width='16' height='16'%3E%3Cpath fill='#e8e8e8' d='M11 10.07h-5.656l5.656-5.656v5.656z'/%3E%3C/svg%3E";
const replaceAll = "%3Csvg version='1.1' xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' x='0px' y='0px' width='16px' height='16px' viewBox='0 0 16 16' enableBackground='new 0 0 16 16' xml:space='preserve'%3E%3Cg id='icon_x5F_bg'%3E%3Cpath fill='#424242' d='M11,15V9H1v6H11z M2,14v-2h1v-1H2v-1h3v4H2z M10,11H8v2h2v1H7v-4h3V11z M3,13v-1h1v1H3z M13,7v6h-1V8H5V7 H13z M13,2V1h-1v5h3V2H13z M14,5h-1V3h1V5z M11,2v4H8V4h1v1h1V4H9V3H8V2H11z'/%3E%3C/g%3E%3Cg id='color_x5F_action'%3E%3Cpath fill='#00539C' d='M1.979,3.5L2,6L1,5v1.5L2.5,8L4,6.5V5L3,6L2.979,3.5c0-0.275,0.225-0.5,0.5-0.5H7V2H3.479 C2.651,2,1.979,2.673,1.979,3.5z'/%3E%3C/g%3E%3C/svg%3E";
const replaceAllInverse = "%3Csvg version='1.1' xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' x='0px' y='0px' width='16px' height='16px' viewBox='0 0 16 16' enable-background='new 0 0 16 16' xml:space='preserve'%3E%3Cg id='icon_x5F_bg'%3E%3Cpath fill='#C5C5C5' d='M11,15V9H1v6H11z M2,14v-2h1v-1H2v-1h3v4H2z M10,11H8v2h2v1H7v-4h3V11z M3,13v-1h1v1H3z M13,7v6h-1V8H5V7 H13z M13,2V1h-1v5h3V2H13z M14,5h-1V3h1V5z M11,2v4H8V4h1v1h1V4H9V3H8V2H11z'/%3E%3C/g%3E%3Cg id='color_x5F_action'%3E%3Cpath fill='#75BEFF' d='M1.979,3.5L2,6L1,5v1.5L2.5,8L4,6.5V5L3,6L2.979,3.5c0-0.275,0.225-0.5,0.5-0.5H7V2H3.479 C2.651,2,1.979,2.673,1.979,3.5z'/%3E%3C/g%3E%3C/svg%3E";
const ellipsis = "%3Csvg xmlns='http://www.w3.org/2000/svg' width='16' height='16'%3E%3Cg fill='#F6F6F6'%3E%3Ccircle cx='3.5' cy='7.5' r='2.5'/%3E%3Ccircle cx='8.5' cy='7.5' r='2.5'/%3E%3Ccircle cx='13.5' cy='7.5' r='2.5'/%3E%3C/g%3E%3Cg fill='#424242'%3E%3Ccircle cx='3.5' cy='7.5' r='1.5'/%3E%3Ccircle cx='8.5' cy='7.5' r='1.5'/%3E%3Ccircle cx='13.5' cy='7.5' r='1.5'/%3E%3C/g%3E%3C/svg%3E";
const ellipsisInverse = "%3Csvg xmlns='http://www.w3.org/2000/svg' width='16' height='16'%3E%3Cg fill='#262626'%3E%3Ccircle cx='3.5' cy='7.5' r='2.5'/%3E%3Ccircle cx='8.5' cy='7.5' r='2.5'/%3E%3Ccircle cx='13.5' cy='7.5' r='2.5'/%3E%3C/g%3E%3Cg fill='#C5C5C5'%3E%3Ccircle cx='3.5' cy='7.5' r='1.5'/%3E%3Ccircle cx='8.5' cy='7.5' r='1.5'/%3E%3Ccircle cx='13.5' cy='7.5' r='1.5'/%3E%3C/g%3E%3C/svg%3E";
const close = `%3Csvg xmlns='http://www.w3.org/2000/svg' width='16' height='16' viewBox='3 3 16 16' enable-background='new 3 3 16 16'%3E%3Cpolygon fill='#424242' points='12.597,11.042 15.4,13.845 13.844,15.4 11.042,12.598 8.239,15.4 6.683,13.845 9.485,11.042 6.683,8.239 8.238,6.683 11.042,9.486 13.845,6.683 15.4,8.239'/%3E%3C/svg%3E`;
const closeDark = `%3Csvg xmlns='http://www.w3.org/2000/svg' width='16' height='16' viewBox='3 3 16 16' enable-background='new 3 3 16 16'%3E%3Cpolygon fill='#FFF' points='12.597,11.042 15.4,13.845 13.844,15.4 11.042,12.598 8.239,15.4 6.683,13.845 9.485,11.042 6.683,8.239 8.238,6.683 11.042,9.486 13.845,6.683 15.4,8.239'/%3E%3C/svg%3E`;
exports.getIcons = (theme) => {
    if (theme.name === 'dark' || theme.name === 'hc') {
        return {
            collapsed: collapsedDark,
            expanded: expandedDark,
            replaceAll: replaceAllInverse,
            ellipsis: ellipsisInverse,
            close: closeDark,
        };
    }
    else {
        return {
            collapsed,
            expanded,
            replaceAll,
            ellipsis,
            close,
        };
    }
};


/***/ }),
/* 9 */
/***/ (function(module, exports) {

module.exports = require("react-tooltip");

/***/ }),
/* 10 */
/***/ (function(module, exports) {

module.exports = require("@files-stack/core");

/***/ }),
/* 11 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(__webpack_require__(12));


/***/ }),
/* 12 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var finder_wrapper_container_1 = __webpack_require__(13);
exports.Finder = finder_wrapper_container_1.default;


/***/ }),
/* 13 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const react_fela_1 = __webpack_require__(1);
const react_redux_1 = __webpack_require__(2);
const react_apollo_1 = __webpack_require__(3);
const client_modal_redux_1 = __webpack_require__(4);
const graphql_gql_1 = __webpack_require__(14);
const client_redux_1 = __webpack_require__(5);
const finder_wrapper_component_1 = __webpack_require__(15);
const FinderWrapperApi = react_apollo_1.graphql(graphql_gql_1.SEARCH_MUTATION, { name: 'searchMutate' })(finder_wrapper_component_1.FinderWrapperComponent);
const mapStateToProps = (state) => ({
    rootPath: state['@files/rootpath'],
    searchOptions: state['@finder/searchOptions'],
});
const mapDispatchToProps = (dispatch) => ({
    setError: (error, type) => dispatch(client_modal_redux_1.setError(error, type)),
    setSearchOptions: (options) => dispatch(client_redux_1.setSearchOptionsAction(options)),
});
const FinderWrapper = react_apollo_1.compose(...[
    react_fela_1.connect({
        container: () => ({
            position: 'relative',
            height: '100%',
            width: '100%',
            '& .__react_component_tooltip': {
                position: 'absolute',
                padding: '2px 4px',
                fontSize: '12px',
                lineHeight: '1.2',
                maxWidth: '100%',
                wordWrap: 'break-word',
                borderRadius: '1px',
            },
            '& .__react_component_tooltip::after': {
                display: 'none',
            },
            '& .__react_component_tooltip.place-bottom': {
                marginTop: '0',
            },
        }),
        header: () => ({
            padding: '9px 22px 0',
            textTransform: 'uppercase',
            fontSize: '0.8em',
            height: '20px',
        }),
    }),
    react_redux_1.connect(mapStateToProps, mapDispatchToProps),
])(FinderWrapperApi);
exports.default = FinderWrapper;


/***/ }),
/* 14 */
/***/ (function(module, exports) {

module.exports = require("@finder-stack/graphql-gql");

/***/ }),
/* 15 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const ReactTooltip = __webpack_require__(9);
const finder_widget_1 = __webpack_require__(16);
const find_results_1 = __webpack_require__(27);
class FinderWrapperComponent extends React.Component {
    constructor(props) {
        super(props);
        this.search = () => {
            const { searchOptions, rootPath } = this.props;
            const searchPath = rootPath;
            const query = {
                type: 'Text',
                contentPattern: {
                    pattern: searchOptions.searchInput,
                },
                folderQueries: [{
                        folder: searchPath,
                    }],
            };
            if (searchOptions.expandDetail) {
                if (searchOptions.filesInclude !== '') {
                    const includePattern = {};
                    searchOptions.filesInclude.split(',').forEach((pattern) => {
                        includePattern[pattern.trim()] = true;
                    });
                    query['includePattern'] = includePattern;
                }
                if (searchOptions.filesExclude !== '') {
                    const excludePattern = {};
                    searchOptions.filesExclude.split(',').forEach((pattern) => {
                        excludePattern[pattern.trim()] = true;
                    });
                    query['excludePattern'] = excludePattern;
                }
            }
            this.props.setSearchOptions({ searchPath });
            this.setState({ results: [] });
            this.props.searchMutate({ variables: { query } })
                .then(({ data: { search } }) => {
                this.setState({ results: search.results });
            })
                .catch((error) => {
                this.props.setError(error.message, 'error');
                this.setState({ results: [] });
            });
        };
        this.state = {
            results: [],
        };
    }
    render() {
        const { styles } = this.props;
        return (React.createElement("div", { ref: (r) => this.containerRef = r, className: styles.container, id: "finder-viewlet" },
            React.createElement("div", { className: styles.header, id: "finder-header" },
                React.createElement("span", null, "Search")),
            React.createElement(finder_widget_1.FinderWidget, { onSearch: this.search }),
            React.createElement(find_results_1.FindResults, { results: this.state.results }),
            React.createElement(ReactTooltip, { id: "finder-tooltip", className: styles.tooltip, place: "bottom", type: "light", effect: "solid", delayShow: 1000, delayHide: 1000 })));
    }
}
exports.FinderWrapperComponent = FinderWrapperComponent;


/***/ }),
/* 16 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var finder_widget_container_1 = __webpack_require__(17);
exports.FinderWidget = finder_widget_container_1.default;


/***/ }),
/* 17 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const react_fela_1 = __webpack_require__(1);
const react_redux_1 = __webpack_require__(2);
const react_apollo_1 = __webpack_require__(3);
const client_modal_redux_1 = __webpack_require__(4);
const client_redux_1 = __webpack_require__(5);
const finder_widget_component_1 = __webpack_require__(18);
const colors_1 = __webpack_require__(7);
const icons_1 = __webpack_require__(8);
const mapStateToProps = (state) => ({
    searchOptions: state['@finder/searchOptions'],
});
const mapDispatchToProps = (dispatch) => ({
    setError: (error, type) => dispatch(client_modal_redux_1.setError(error, type)),
    setSearchOptions: (options) => dispatch(client_redux_1.setSearchOptionsAction(options)),
});
exports.default = react_apollo_1.compose(...[
    react_redux_1.connect(mapStateToProps, mapDispatchToProps),
    react_fela_1.connect({
        container: () => ({
            margin: '0px 9px 0 2px',
        }),
        searchInput: () => ({
            position: 'relative',
        }),
        toggleReplaceButton: ({ theme }) => (Object.assign({ position: 'absolute', top: '0', left: '0', width: '16px', height: '100%', '-webkit-box-sizing': 'border-box', '-o-box-sizing': 'border-box', '-moz-box-sizing': 'border-box', '-ms-box-sizing': 'border-box', 'box-sizing': 'border-box', 'background-position': 'center center', 'background-repeat': 'no-repeat', cursor: 'pointer', '&.collapse': {
                'background-image': `url("data:image/svg+xml;charset=utf-8,${icons_1.getIcons(theme).collapsed}")`,
            }, '&.expand': {
                'background-image': `url("data:image/svg+xml;charset=utf-8,${icons_1.getIcons(theme).expanded}")`,
            } }, colors_1.getToggleReplaceButtonColors(theme))),
        inputBox: ({ theme }) => (Object.assign({ fontSize: '13px', marginLeft: '17px', width: 'calc(100% - 17px) !important', height: '25px', position: 'relative', display: 'block', padding: '0', '-webkit-box-sizing': 'border-box', '-o-box-sizing': 'border-box', '-moz-box-sizing': 'border-box', '-ms-box-sizing': 'border-box', boxSizing: 'border-box', lineHeight: 'auto !important', '& .wrapper': {
                position: 'relative',
                width: '100%',
                height: '100%',
            } }, colors_1.getInputColors(theme))),
        replaceInputBox: () => ({
            marginTop: '6px',
            position: 'relative',
            display: 'inline-flex',
            '&.disabled': {
                display: 'none',
            },
        }),
        replaceAction: () => ({
            marginLeft: '3px',
        }),
        replaceActionIcon: ({ theme }) => ({
            display: 'block',
            'background-image': `url("data:image/svg+xml;charset=utf-8,${icons_1.getIcons(theme).replaceAll}")`,
            'background-repeat': 'no-repeat',
            width: '20px',
            height: '25px',
        }),
    }),
])(react_fela_1.withTheme(finder_widget_component_1.FinderWidgetComponent));


/***/ }),
/* 18 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const toggle_replace_button_1 = __webpack_require__(19);
const search_input_1 = __webpack_require__(20);
const query_details_1 = __webpack_require__(21);
class FinderWidgetComponent extends React.Component {
    constructor(props) {
        super(props);
        this.keyDown = (e) => {
            if (e.key === 'Enter') {
                this.props.onSearch();
            }
        };
        this.setExpand = (expand) => {
            this.props.setSearchOptions({ expandReplace: expand });
        };
        this.changeSearch = (input) => {
            this.props.setSearchOptions({ searchInput: input });
        };
        this.changeReplace = (input) => {
            this.props.setSearchOptions({ replaceInput: input });
        };
    }
    render() {
        const { styles, searchOptions } = this.props;
        return (React.createElement("div", { id: "finder-widget", className: styles.container, onKeyDown: this.keyDown },
            React.createElement("div", { className: styles.searchInput },
                React.createElement(toggle_replace_button_1.ToggleReplaceButton, { styles: styles, expand: searchOptions.expandReplace, onUpdate: this.setExpand }),
                React.createElement(search_input_1.SearchInput, { styles: styles, placeholder: "Search", input: searchOptions.searchInput, onChange: this.changeSearch }),
                searchOptions.expandReplace === true &&
                    React.createElement(search_input_1.SearchInput, { styles: styles, placeholder: "Replace", isReplace: true, input: searchOptions.replaceInput, onChange: this.changeReplace })),
            React.createElement(query_details_1.QueryDetails, null)));
    }
}
exports.FinderWidgetComponent = FinderWidgetComponent;


/***/ }),
/* 19 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const cx = __webpack_require__(6);
class ToggleReplaceButton extends React.Component {
    constructor() {
        super(...arguments);
        this.handleClick = (e) => {
            const expand = this.props.expand === true;
            this.props.onUpdate(!expand);
        };
    }
    render() {
        const { styles, expand } = this.props;
        const className = cx(styles.toggleReplaceButton, {
            collapse: expand !== true,
            expand: expand === true,
        });
        return (React.createElement("a", { className: className, onClick: this.handleClick, title: "Toggle Replace" }));
    }
}
exports.ToggleReplaceButton = ToggleReplaceButton;


/***/ }),
/* 20 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const cx = __webpack_require__(6);
class SearchInput extends React.Component {
    constructor(props) {
        super(props);
        this.changeInput = (e) => {
            this.props.onChange(e.target.value);
        };
    }
    render() {
        const { input, styles, placeholder, isReplace } = this.props;
        const className = isReplace ?
            cx(styles.inputBox, styles.replaceInputBox) : styles.inputBox;
        return (React.createElement("div", { className: className },
            React.createElement("div", { className: "wrapper" },
                React.createElement("input", { type: "text", placeholder: placeholder, value: input, onChange: this.changeInput })),
            isReplace &&
                React.createElement("div", { className: styles.replaceAction },
                    React.createElement("a", { className: styles.replaceActionIcon }))));
    }
}
exports.SearchInput = SearchInput;


/***/ }),
/* 21 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var query_details_container_1 = __webpack_require__(22);
exports.QueryDetails = query_details_container_1.default;


/***/ }),
/* 22 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const react_fela_1 = __webpack_require__(1);
const react_redux_1 = __webpack_require__(2);
const react_apollo_1 = __webpack_require__(3);
const client_modal_redux_1 = __webpack_require__(4);
const client_redux_1 = __webpack_require__(5);
const query_details_component_1 = __webpack_require__(23);
const colors_1 = __webpack_require__(7);
const icons_1 = __webpack_require__(8);
const mapStateToProps = (state) => ({
    searchOptions: state['@finder/searchOptions'],
});
const mapDispatchToProps = (dispatch) => ({
    setError: (error, type) => dispatch(client_modal_redux_1.setError(error, type)),
    setSearchOptions: (options) => dispatch(client_redux_1.setSearchOptionsAction(options)),
});
const QueryDetails = react_apollo_1.compose(...[
    react_redux_1.connect(mapStateToProps, mapDispatchToProps),
    react_fela_1.connect({
        container: () => ({
            minHeight: '1em',
            position: 'relative',
            margin: '5px 0 0 17px',
        }),
        toggleSearchDetailsButton: ({ theme }) => ({
            position: 'absolute',
            marginRight: '0.3em',
            right: '0',
            cursor: 'pointer',
            width: '16px',
            height: '13px',
            zIndex: '2',
            background: `url("data:image/svg+xml;charset=utf-8,${icons_1.getIcons(theme).ellipsis}") top center no-repeat`,
        }),
        inputBox: ({ theme }) => (Object.assign({ width: '100%', display: 'block', position: 'relative', paddingTop: '5px', fontSize: '12px', '&:last-child': {
                paddingBottom: '10px',
            }, '& .wrapper': {
                position: 'relative',
                height: '25px',
                width: '100%',
            } }, colors_1.getInputColors(theme))),
    }),
])(react_fela_1.withTheme(query_details_component_1.QueryDetailsComponent));
exports.default = QueryDetails;


/***/ }),
/* 23 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const toggle_search_details_button_1 = __webpack_require__(24);
const files_input_1 = __webpack_require__(25);
class QueryDetailsComponent extends React.Component {
    constructor() {
        super(...arguments);
        this.setExpand = (expand) => {
            if (!expand) {
                this.props.setSearchOptions({
                    expandDetail: expand,
                    filesInclude: '',
                    filesExclude: '',
                });
            }
            else {
                this.props.setSearchOptions({
                    expandDetail: expand,
                });
            }
        };
        this.changeFilesInclude = (path) => {
            this.props.setSearchOptions({ filesInclude: path });
        };
        this.changeFilesExclude = (path) => {
            this.props.setSearchOptions({ filesExclude: path });
        };
    }
    render() {
        const { styles, searchOptions } = this.props;
        return (React.createElement("div", { ref: (r) => this.containerRef = r, className: styles.container },
            React.createElement(toggle_search_details_button_1.ToggleSearchDetailsButton, { styles: styles, expand: searchOptions.expandDetail, onUpdate: this.setExpand }),
            searchOptions.expandDetail === true &&
                React.createElement(files_input_1.FilesInput, { styles: styles, input: searchOptions.filesInclude, onChange: this.changeFilesInclude }),
            searchOptions.expandDetail === true &&
                React.createElement(files_input_1.FilesInput, { styles: styles, isExclude: true, input: searchOptions.filesExclude, onChange: this.changeFilesExclude })));
    }
}
exports.QueryDetailsComponent = QueryDetailsComponent;


/***/ }),
/* 24 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
class ToggleSearchDetailsButton extends React.Component {
    constructor(props) {
        super(props);
        this.handleClick = this.handleClick.bind(this);
    }
    handleClick(e) {
        const expand = this.props.expand === true;
        this.props.onUpdate(!expand);
    }
    render() {
        const { styles } = this.props;
        return (React.createElement("a", { className: styles.toggleSearchDetailsButton, onClick: this.handleClick, title: "Toggle Search Details" }));
    }
}
exports.ToggleSearchDetailsButton = ToggleSearchDetailsButton;


/***/ }),
/* 25 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const cx = __webpack_require__(6);
class FilesInput extends React.Component {
    constructor() {
        super(...arguments);
        this.change = (e) => {
            this.props.onChange(e.target.value);
        };
    }
    render() {
        const { styles, input, isExclude } = this.props;
        const className = isExclude ?
            cx(styles.inputBox, styles.filesExcludeBox) : styles.inputBox;
        return (React.createElement("div", { className: styles.inputBox },
            React.createElement("span", null, isExclude ? 'files to exclude' : 'files to include'),
            React.createElement("div", { className: "wrapper" },
                React.createElement("input", { type: "text", value: input, onChange: this.change }))));
    }
}
exports.FilesInput = FilesInput;


/***/ }),
/* 26 */
/***/ (function(module, exports) {

module.exports = require("@workbench-stack/client-theme-redux");

/***/ }),
/* 27 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var find_results_container_1 = __webpack_require__(28);
exports.FindResults = find_results_container_1.default;


/***/ }),
/* 28 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const react_fela_1 = __webpack_require__(1);
const react_redux_1 = __webpack_require__(2);
const react_apollo_1 = __webpack_require__(3);
const client_modal_redux_1 = __webpack_require__(4);
const find_results_component_1 = __webpack_require__(29);
const colors_1 = __webpack_require__(7);
const mapStateToProps = (state) => ({
    width: state['resize'].treePanel,
});
const mapDispatchToProps = (dispatch) => ({
    setError: (error, type) => dispatch(client_modal_redux_1.setError(error, type)),
});
exports.default = react_apollo_1.compose(...[
    react_fela_1.connect({
        stats: () => ({
            paddingLeft: '20px',
            opacity: '.5',
        }),
        list: () => ({
            position: 'relative',
            backgroundColor: 'transparent',
            overflow: 'hidden',
        }),
        tree: ({ theme }) => ({
            overflowY: 'auto',
            overflowX: 'hidden',
            '& .rst__virtualScrollOverride': Object.assign({ '&::-webkit-scrollbar': {
                    width: '6px',
                }, '&::-webkit-scrollbar-thumb': {
                    opacity: '.5',
                } }, colors_1.getScrollColors(theme)),
        }),
    }),
    react_redux_1.connect(mapStateToProps, mapDispatchToProps),
])(react_fela_1.withTheme(find_results_component_1.FindResultsComponent));


/***/ }),
/* 29 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const ReactTooltip = __webpack_require__(9);
const react_sortable_tree_1 = __webpack_require__(30);
const core_1 = __webpack_require__(10);
const FindResultsTreeTheme = __webpack_require__(31);
class FindResultsComponent extends React.Component {
    constructor(props) {
        super(props);
        this.getTreeData = (results) => {
            const treeData = results.map((fileMatch) => ({
                resource: fileMatch.resource,
                folder: this.filterFolder(fileMatch.resource),
                file: core_1.getFileName(fileMatch.resource),
                children: fileMatch.lineMatches.map((lineMatch, i) => (Object.assign({}, lineMatch, { id: `${fileMatch.resource}_${i}` }))),
                isDirectory: true,
                expanded: true,
            }));
            this.setState({ treeData });
        };
        this.changeTree = (treeData) => {
            this.setState({ treeData });
        };
        this.removeNode = (node, path) => {
            const result = react_sortable_tree_1.removeNode({
                treeData: this.state.treeData,
                path,
                getNodeKey: ({ treeIndex }) => treeIndex,
            });
            this.changeTree(result.treeData);
        };
        this.state = {
            height: 0,
            treeData: [],
        };
    }
    componentWillReceiveProps(nextProps) {
        const { results } = nextProps;
        if (results && results.length !== this.props.results.length) {
            this.getTreeData(results);
        }
    }
    componentDidUpdate(prevProps, prevState) {
        const finderContainer = document.getElementById('finder-viewlet') || document.body;
        const finderHeader = document.getElementById('finder-header');
        const finderWidget = document.getElementById('finder-widget');
        const resultsState = document.getElementById('finder-results-stats');
        const containerHeight = finderContainer.clientHeight;
        let heightOffset = 0;
        if (resultsState) {
            heightOffset = heightOffset + resultsState.clientHeight;
        }
        if (finderHeader) {
            heightOffset = heightOffset + finderHeader.clientHeight;
        }
        if (finderWidget) {
            heightOffset = heightOffset + finderWidget.clientHeight;
        }
        const height = containerHeight - heightOffset;
        if (height !== this.state.height) {
            this.setState({ height });
        }
        if (this.state.treeData) {
            setTimeout(() => {
                ReactTooltip.rebuild();
            }, 100);
        }
    }
    filterFolder(resource) {
        return resource.replace(`file://${this.props.folder}/`, '');
    }
    renderStats() {
        const { results, styles } = this.props;
        const { treeData } = this.state;
        let matches = 0;
        let files = treeData.length;
        treeData.forEach((node) => {
            matches = matches + node.children.length;
        });
        return (React.createElement("div", { id: "finder-results-stats" },
            React.createElement("span", { className: styles.stats },
                matches,
                " results in ",
                files,
                " files")));
    }
    render() {
        const { styles, width } = this.props;
        const { treeData, height } = this.state;
        const nodeProps = (rowInfo) => ({
            removeNode: this.removeNode,
        });
        return (React.createElement("div", { ref: (r) => this.containerRef = r },
            this.renderStats(),
            React.createElement("div", { className: styles.list, style: { height, width } },
                React.createElement(react_sortable_tree_1.default, { id: "finder-folders-list", className: styles.tree, treeData: treeData, onChange: this.changeTree, theme: FindResultsTreeTheme, generateNodeProps: nodeProps }))));
    }
}
exports.FindResultsComponent = FindResultsComponent;


/***/ }),
/* 30 */
/***/ (function(module, exports) {

module.exports = require("@cdmbase/react-sortable-tree");

/***/ }),
/* 31 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var tree_node_content_1 = __webpack_require__(32);
exports.nodeContentRenderer = tree_node_content_1.default;
var tree_node_1 = __webpack_require__(37);
exports.treeNodeRenderer = tree_node_1.default;
exports.scaffoldBlockPxWidth = 4;
exports.rowHeight = 22;
exports.slideRegionSize = 50;


/***/ }),
/* 32 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const ReactDOM = __webpack_require__(33);
const cx = __webpack_require__(6);
const react_apollo_1 = __webpack_require__(3);
const react_fela_1 = __webpack_require__(1);
const react_redux_1 = __webpack_require__(2);
const core_1 = __webpack_require__(10);
const client_redux_1 = __webpack_require__(34);
const client_redux_2 = __webpack_require__(5);
const selector_1 = __webpack_require__(35);
const colors_1 = __webpack_require__(7);
const icons_1 = __webpack_require__(8);
class TreeNodeContent extends React.Component {
    constructor(props) {
        super(props);
        this.handleClick = (e) => {
            e.preventDefault();
            const { node, path, parentNode } = this.props;
            if (node.isDirectory) {
                this.props.toggleChildrenVisibility({
                    node,
                    path,
                });
            }
            else {
                this.props.selectNode(node.id);
                if (parentNode && parentNode.resource) {
                    this.props.openFile(parentNode.resource, core_1.getFileName(parentNode.resource));
                    this.props.setFinderOptions({
                        lineNumber: node.lineNumber,
                        searchText: this.props.searchOptions.searchInput,
                    });
                }
            }
        };
        this.remove = () => {
            const { node, path } = this.props;
            this.props.removeNode(node, path);
        };
    }
    componentDidMount() {
        this.setPathWidth();
    }
    componentDidUpdate(prevProps, prevState) {
        this.setPathWidth();
    }
    setPathWidth() {
        if (this.fileNameRef && this.filePathRef) {
            const maxWidth = document.getElementById('finder-viewlet').clientWidth - 36;
            const nameWidth = ReactDOM.findDOMNode(this.fileNameRef).clientWidth;
            const width = maxWidth - nameWidth - 13;
            const element = ReactDOM.findDOMNode(this.filePathRef);
            element.style.width = `${Math.max(width, 0)}px`;
        }
    }
    nodeFolder(path) {
        const { searchOptions } = this.props;
        return core_1.getPath(path).replace(searchOptions.searchPath + '/', '');
    }
    nodePreview(preview) {
        const { searchOptions } = this.props;
        let nodePreview;
        const replace = searchOptions.expandReplace && searchOptions.replaceInput ?
            searchOptions.replaceInput : '';
        if (replace !== '') {
            nodePreview = preview.replace(searchOptions.searchInput, `<del>${searchOptions.searchInput}</del>
         <mark class="green">${replace}</mark>`);
        }
        else {
            nodePreview = preview.replace(searchOptions.searchInput, `<mark>${searchOptions.searchInput}</mark>`);
        }
        return (React.createElement("span", { dangerouslySetInnerHTML: { __html: nodePreview } }));
    }
    renderScaffold() {
        const { scaffoldBlockPxWidth, lowerSiblingCounts, styles, } = this.props;
        const scaffold = [];
        lowerSiblingCounts.forEach((lowerSiblingCount, i) => {
            scaffold.push(React.createElement("div", { key: `pre_${1 + i}`, style: { width: scaffoldBlockPxWidth }, className: styles.lineBlock }));
        });
        return scaffold;
    }
    render() {
        const { node, path, style, styles, selected, scaffoldBlockPxWidth, lowerSiblingCounts } = this.props;
        const nodeName = node.isDirectory ? node.file : this.nodePreview(node.preview);
        const tootipAttrs = {
            'data-for': 'finder-tooltip',
            'data-tip': node.isDirectory ? this.nodeFolder(node.folder) : node.preview.substring(0, 75),
        };
        const wrapperClassName = cx(styles.wrapper, {
            'selected': selected,
        });
        const rowClassName = cx(styles.row, {
            'has-children': node.isDirectory,
            'expanded': node.expanded,
        });
        const rowStyle = Object.assign({ width: `calc(100% - ${lowerSiblingCounts.length * scaffoldBlockPxWidth}px)` }, style);
        return (React.createElement("div", { ref: (r) => { this.containerRef = r; }, className: styles.node },
            React.createElement("div", { className: wrapperClassName },
                this.renderScaffold(),
                React.createElement("div", { className: rowClassName, style: rowStyle, onClick: this.handleClick },
                    React.createElement("div", { className: styles.label },
                        React.createElement("a", Object.assign({ ref: (r) => { this.fileNameRef = r; }, className: styles.fileName }, tootipAttrs), nodeName),
                        node.isDirectory &&
                            React.createElement("span", { ref: (r) => { this.filePathRef = r; }, className: styles.path }, this.nodeFolder(node.folder)))),
                React.createElement("a", { className: cx('close', styles.close), onClick: this.remove }))));
    }
}
TreeNodeContent.defaultProps = {
    parentNode: null,
    style: {},
};
const makeMapStateToProps = (initialState, ownProps) => {
    const getSelectedState = selector_1.makeGetSelectedState();
    const mapStateToProps = (state, props) => ({
        selected: getSelectedState(state, props),
        searchOptions: state['@finder/searchOptions'],
    });
    return mapStateToProps;
};
const mapDispatchToProps = (dispatch, props) => ({
    selectNode(id) {
        dispatch(client_redux_2.selectNodeAction(id));
    },
    openFile(resource, name) {
        dispatch(client_redux_1.openFileAction({ resource: core_1.getPath(resource), name }));
    },
    setFinderOptions: (options) => dispatch(client_redux_1.setFinderOptionsAction(options)),
});
exports.default = react_apollo_1.compose(react_redux_1.connect(makeMapStateToProps, mapDispatchToProps), react_fela_1.connect({
    node: () => ({
        position: 'relative',
        minWidth: '100%',
    }),
    wrapper: ({ theme }) => (Object.assign({ position: 'relative', display: 'flex', ':hover a.close': {
            display: 'inline-block',
        } }, colors_1.getNodeContentColors(theme))),
    lineBlock: () => ({
        height: '100%',
        position: 'relative',
        display: 'inline-block',
        flex: '0 0 auto',
    }),
    row: ({ theme }) => ({
        height: '100%',
        whiteSpace: 'nowrap',
        display: 'flex',
        position: 'relative',
        ':before': {
            paddingRight: '6px',
            width: '16px',
            height: '22px',
            display: 'inline-block',
            verticalAlign: 'top',
            content: '" "',
        },
        '&.has-children:before': {
            backgroundSize: '16px',
            backgroundPosition: '50% 50%',
            backgroundRepeat: 'no-repeat',
            backgroundImage: `url("data:image/svg+xml;charset=utf-8,${icons_1.getIcons(theme).collapsed}")`,
        },
        '&.has-children.expanded:before': {
            backgroundImage: `url("data:image/svg+xml;charset=utf-8,${icons_1.getIcons(theme).expanded}")`,
        },
    }),
    label: () => ({
        width: 'calc(100% - 28px)',
        cursor: 'pointer',
    }),
    close: ({ theme }) => ({
        position: 'absolute',
        display: 'none',
        verticalAlign: 'middle',
        cursor: 'pointer',
        height: '10px',
        width: '16px',
        top: '6px',
        right: '14px',
        backgroundSize: '16px',
        backgroundPosition: '50% 50%',
        backgroundRepeat: 'no-repeat',
        backgroundImage: `url("data:image/svg+xml;charset=utf-8,${icons_1.getIcons(theme).close}")`,
    }),
    fileName: ({ theme }) => (Object.assign({ display: 'inline-block', verticalAlign: 'middle', overflow: 'hidden', textOverflow: 'ellipsis', maxWidth: 'calc(100% - 14px)', whiteSpace: 'nowrap' }, colors_1.getHighlightColors(theme))),
    path: () => ({
        display: 'inline-block',
        verticalAlign: 'middle',
        paddingLeft: '6px',
        opacity: '.7',
        textOverflow: 'ellipsis',
        overflow: 'hidden',
        whiteSpace: 'nowrap',
    }),
}))(react_fela_1.withTheme(TreeNodeContent));


/***/ }),
/* 33 */
/***/ (function(module, exports) {

module.exports = require("react-dom");

/***/ }),
/* 34 */
/***/ (function(module, exports) {

module.exports = require("@files-stack/client-redux");

/***/ }),
/* 35 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const reselect_1 = __webpack_require__(36);
exports.makeGetSelectedState = () => {
    return reselect_1.createSelector((state, props) => ({ node: props.node, selectedNode: state['@finder/selectedNode'] }), ({ node, selectedNode }) => (node && node.id && node.id === selectedNode));
};


/***/ }),
/* 36 */
/***/ (function(module, exports) {

module.exports = require("reselect");

/***/ }),
/* 37 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
exports.default = (props) => {
    const { style, children, listIndex, lowerSiblingCounts } = props;
    return (React.createElement("div", { style: style }, React.Children.map(children, (child) => React.cloneElement(child, {
        listIndex,
        lowerSiblingCounts,
    }))));
};


/***/ })
/******/ ]);
//# sourceMappingURL=index.js.map